program IsciPodniz(Input, Output); { RTK 1988.3.2 }
{ Ugotovi, kolikokrat podniz nastopa v nizu. } 
const MaxDolz = 200; 
type NizT = packed array[1..MaxDolz] of char; 
var Niz, Podniz: NizT;
    Stevilo: integer;  { tevilo pojavitev niza v podnizu } 

{ Primerja del niza od ZacNiz dalje s podnizom od ZacPodniz dalje. } 
procedure Primerjaj(ZacNiz, ZacPodniz: integer; var Stevilo: integer); 
begin
  if (ZacNiz > MaxDolz) or (ZacPodniz > MaxDolz) then begin end
  else if Podniz[ZacPodniz] in [#0, ' '] then Stevilo := Stevilo + 1 
  else begin 
    while ZacNiz <= MaxDolz do begin 
      if Niz[ZacNiz] = Podniz[ZacPodniz] then 
        Primerjaj(ZacNiz + 1, ZacPodniz + 1, Stevilo); 
      ZacNiz := ZacNiz + 1; 
    end; {while}
  end; {if}
end; {Primerjaj} 

var S: string;
begin
  if ParamCount >= 2 then begin
    Niz := ParamStr(1);
    Podniz := ParamStr(2);
  end else begin
    Write('Vnesi niz: '); ReadLn(Niz);
    Write('Vnesi podniz: '); ReadLn(Podniz);
  end; {if}
  Stevilo := 0; Primerjaj(1, 1, Stevilo); 
  WriteLn; 
  WriteLn('Podniz "', Podniz, '" se ', Stevilo, '-krat ', 
    'pojavi v nizu "', Niz, '".'); 
end. {IsciPodniz}
