program StevilaZBesedami; { RTK 1989.1.4 }

procedure IzpisiStevko(Stevka: integer; Dva: boolean; ZaStevko: string); 
begin
  case Stevka of 
  1: Write('ena'); 
  2: if Dva then Write('dva') else Write('dve'); 
  3: Write('tri'); 
  4: Write('tiri'); 
  5: Write('pet'); 
  6: Write('est'); 
  7: Write('sedem'); 
  8: Write('osem'); 
  9: Write('devet'); 
  end; {case} 
  Write(ZaStevko); 
end; {IzpisiStevko} 

procedure IzpisiStevilo(Stevilo: integer); 
var S, D, E: integer; 
begin
  if Stevilo = 0 then 
    Write('ni') 
  else begin 
    { Razbijmo tevilo na posamezne tevke: 
      S = stotice, D = desetice, E = enice. }
    E := Stevilo mod 10; 
    Stevilo := Stevilo div 10; 
    D := Stevilo mod 10; 
    S := Stevilo div 10; 
    case S of { stotice }
      1: Write('sto'); 
      2..9: IzpisiStevko(S, false, 'sto'); 
    end; {case}
    { Med stoticami in deseticami/enicami je presledek. }
    if (S > 0) and (D + E > 0) then Write(' '); 
    { Izpiimo e desetice in enice. }
    case D of 
      0: { samo enice }
        if E > 0 then IzpisiStevko(E, false, ''); 
      1: case E of
          0: Write('deset'); 
          1: Write('enajst'); 
          2..9: IzpisiStevko(E, true, 'najst'); 
        end;
      2..9: 
        begin
          if E > 0 then IzpisiStevko(E, true, 'in'); 
          IzpisiStevko(D, true, ''); { dva[jset], tri[deset], ..., devet[deset] }
          if D = 2 then Write('jset') else Write('deset'); 
        end;
    end; {case} 
  end; {if}
  WriteLn; 
end; {IzpisiStevilo} 

var Stevilo: integer; 
begin {StevilaZBesedami}
  for Stevilo := 0 to 999 do IzpisiStevilo(Stevilo); 
end. {StevilaZBesedami}

