program Kaj; { RTK 1991.3.1 }
type byte = 0..255; { osembitna nepredznaena tevila } 

{ Razliica s komentarji. }

{ Funkcija vrne kvocient a/b dveh nepredznaenih 8-bitnih tevil. }
function KajStorim(a, b: byte): byte; 
var 
  Stevec: byte; 
  Rezultat: byte; { Tu bomo sestavljali rezultat. } 
  Premik: byte;   { Tu zbiramo tevilke levo od oznaenega mesta. } 
begin
  Rezultat := 0; Premik := 0; 
  for Stevec := 1 to 8 do begin 
    Premik := 2 * Premik + (a div 128); { Zgornji bit a dodamo v Premik. } 
    a := (a mod 128) * 2;       { Premaknemo bite v levo. } 
    Rezultat := 2 * Rezultat;   { V rezultat dodamo v spodnji bit nilo. }
    if Premik >= b then begin   { e je dobljeno tevilo e veje od delitelja, }
      Premik := Premik - b;     { ga zmanjamo za delitelj. } 
      Rezultat := Rezultat + 1; { Nilo v rezultatu spremenimo v ena. } 
    end; {if}
  end; {for}
  KajStorim := Rezultat; 
end; {KajStorim} 

var a, b: byte; i: integer;
begin {Kaj}
  if ParamCount >= 2 then begin
    Val(ParamStr(1), a, i);
    Val(ParamStr(2), b, i);
  end else begin
    Write('Vnesi dve tevili: ');
    ReadLn(a, b);
  end; {if}
  WriteLn('KajStorim(', a, ', ', b, ') = ', KajStorim(a, b));
end. {Kaj}

