program CastniGost(Input, Output); { RTK 1992.1.4 }
type GostT = integer; 

    function Pozna(a, b: GostT): boolean; forward; 

procedure KdoJeCastniGost(N: integer);
var a, b: GostT; 
begin
  a := 1; 
  b := N; 
  while a <> b do 
    if Pozna(a, b) then a := a + 1  { e a pozna b, potem a ni astni gost. } 
    else b := b - 1;                { e a ne pozna b, potem b ni astni gost. } 
  WriteLn('astni gost je oseba ', a, '.'); 
end; {KdoJeCastniGost} 

var n, Castni: GostT; p, i: integer;

function Pozna(a, b: GostT): boolean;
begin
  if b = Castni then Pozna := true
  else if a = Castni then Pozna := false
  else begin
    { Z nastavitvijo RandSeed bi radi zagotovili,
      da bo Pozna(a, b), e jo kliejo vekrat za
      isti par (a, b), vraala ves as isto vrednost. }
    RandSeed := n * (a - 1) + b;
    Pozna := Random(100) < p;
  end; {if}
end; {Pozna}

begin
  if ParamCount < 3 then begin
    WriteLn('Sintaksa: rtk92s1n4 StGostov CastniGost DelezPoznanihVOdstotkih');
    exit;
  end; {if}
  Val(ParamStr(1), n, i);
  Val(ParamStr(2), Castni, i);
  Val(ParamStr(3), p, i);
  KdoJeCastniGost(n);
end. {CastniGost}
