@echo off
rem   ------------------------------------------------------------------
rem   Paketna datoteka za testiranje reitve naloge RTK 1996.Z
rem   (2. zakljuno tekmovanje iz znanja raunalnitva)
rem   ------------------------------------------------------------------
rem   Na trenutnem direktoriju morajo biti prisotne naslednje datoteke:
rem   - rtk96sZ-pripravi.pas (program za pripravo indeksnih datotek)
rem   - rtk96sZ.pas (reitev naloge)
rem   - zirija.pas (uporablja jo rtk96sZ.pas)
rem   - k1000.txt, k10000.txt, k100000.txt (opisi kartic)
rem   - zreb.txt (uporablja jo zirija.pas)
rem   - 1000.ref, 10000.ref, 100000.ref (pravilni rezultati).


ppc386 rtk96sZ-pripravi -Cr -gl
echo.
echo Pripravljam indeksne datoteke.
echo.
rtk96sZ-pripravi 1000
rtk96sZ-pripravi 10000
rtk96sZ-pripravi 100000

ppc386 rtk96sZ -Cr -gl
echo.
echo Reujem testne primere.
echo.
rtk96sZ 1000 > out1000.txt
rtk96sZ 10000 > out10000.txt
rtk96sZ 100000 > out100000.txt

echo.
echo Primerjam dobljene reitve s pravilnimi.
echo Razlika bi smela biti le v asu izvajanja.
echo.
fc out1000.txt 1000.ref
fc out10000.txt 10000.ref
fc out100000.txt 100000.ref
