program PisanjeVRom; { RTK 1997.3.3 }
const MaxFlashROM = 65536;

var 
  FlashROM: array[1..MaxFlashROM] of integer;
  
  procedure Vpisi(Naslov, Vrednost: integer);
    begin FlashROM[Naslov] := FlashROM[Naslov] or Vrednost; end;
  
var
  Indeksi, Cene, OdKod: array[1..MaxFlashROM] of integer; 
  Zadnji, Lokacija, Velikost, Zapis: integer; 
  T: text;
begin
  { Velikosti zapisov na Flash ROMu preberimo iz datoteke. 
    Konajo naj se z nilo. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk97s3n3.in');
  Reset(T);
  for Lokacija := 1 to MaxFlashROM do FlashROM[Lokacija] := 0;
  Lokacija := 1;
  while not Eof(T) do begin
    Read(T, Velikost); if Velikost <= 0 then break;
    FlashRom[Lokacija] := Velikost;
    Lokacija := Lokacija + Velikost;
  end; {while}
  Close(T);

  Indeksi[1] := 1; 
  Cene[1] := 0; 
  OdKod[1] := 0; 
  Lokacija := FlashROM[1] + 1; 
  Zadnji := 1; 
  while FlashROM[Lokacija] <> 0 do begin 
    Zadnji := Zadnji + 1; 
    Indeksi[Zadnji] := Lokacija; 
    Cene[Zadnji] := Cene[Zadnji - 1] + 1; 
    OdKod[Zadnji] := Zadnji - 1; 
    for Zapis := 1 to Zadnji - 2 do begin 
      if Cene[Zapis] + 1 < Cene[Zadnji] then begin 
        { Splaalo bi se skoiti od zapisa Zapis do zapisa Zadnji; 
          preverimo, e je tak skok sploh mogo. }
        Velikost := (Lokacija - Indeksi[Zapis]) or FlashROM[Indeksi[Zapis]]; 
        if Indeksi[Zapis] + Velikost = Lokacija then begin 
          Cene[Zadnji] := Cene[Zapis] + 1; 
          OdKod[Zadnji] := Zapis; 
        end; {if}
      end; {if}
    end; {for}
    WriteLn('Najceneja pot do ', Zadnji, ' (naslov ', Indeksi[Zadnji], 
      '): od ', OdKod[Zadnji], ' (naslov ', Indeksi[OdKod[Zadnji]], 
      '), t. skokov = ', Cene[Zadnji]);
    Lokacija := Lokacija + FlashROM[Lokacija]; 
  end; {while}
  Write('Najceneja pot do ', Zadnji, ': ', Zadnji);
  while Zadnji <> 1 do begin 
    Zapis := OdKod[Zadnji]; 
    Vpisi(Indeksi[Zapis], Indeksi[Zadnji] - Indeksi[Zapis]); 
    Zadnji := Zapis; 
    Write(' <-- ', Zadnji);
  end; {while}
  WriteLn;
end. {PisanjeVRom}
