program Utopija; { RTK 1999.1.4 }

const MaxPreb = 100; 
type Tabela = array[1..MaxPreb] of real; 

{ Tabela mora biti urejena naraajoe. } 
procedure Razdeli(var Premozenje: Tabela; StPreb: integer; Kup: real); 
var StPrej: integer; { tevilo prejemnikov } 
    Vsota, Novo: real; 
begin

  StPrej := 0; Vsota := 0; 
  while StPrej < StPreb do begin 
    { Invarianta: kup je dovolj velik, da damo lahko 
      najrevnejim StPrej - 1 ljudem toliko, da bodo 
      imeli enako kot oseba StPrej. }
    if Vsota + Kup <= Premozenje[StPrej + 1] * StPrej then break; 
    StPrej := StPrej + 1; 
    Vsota := Vsota + Premozenje[StPrej];  
  end; {while}

  if StPrej > 0 then begin
    Novo := (Vsota + Kup) / StPrej; 
    while StPrej > 0 do begin
      Premozenje[StPrej] := Novo; 
      StPrej := StPrej - 1;
    end; {while}
  end; {if}

end; {Razdeli} 

var i, j, StPreb: integer; 
    Premozenje: tabela; x, Meja, Kup: real;
begin
  
  { Preberimo podatke o premoenju prebivalcev.
    Za vsak primer jih bomo e uredili (z vstavljanjem). 
    Spotoma raunajmo vsoto premoenja. }
  WriteLn('Vnesi tevilo prebivalcev in njihova premoenja: ');
  Read(StPreb); Kup := 0;
  for i := 1 to StPreb do begin
    Read(x); Kup := Kup + x;
    j := i - 1;
    while j > 0 do 
      if Premozenje[j] <= x then break
      else begin Premozenje[j + 1] := Premozenje[j]; j := j - 1; end;
    Premozenje[j + 1] := x;
  end; {for}
  Write('Zaetno stanje:'); for i := 1 to StPreb do Write(' ', Premozenje[i]:0:2); WriteLn;
  
  { Izraunajmo najveje sprejemljivo premoenje. }
  Meja := (Kup / StPreb) * 1.5;
  
  { Oskubimo bogatae. }
  Kup := 0; i := StPreb;
  while i > 0 do 
    if Premozenje[i] <= Meja then break
    else begin Kup := Kup + Premozenje[i] - Meja; Premozenje[i] := Meja; i := i - 1; end;
  Write('Po odvzemu:    '); for i := 1 to StPreb do Write(' ', Premozenje[i]:0:2); WriteLn;
  WriteLn('Kup = ', Kup:0:2);
  
  { Razdelimo denar reveem. }
  Razdeli(Premozenje, StPreb, Kup);
  { Izpiimo rezultate. }
  Write('Po delitvi:   '); for i := 1 to StPreb do Write(Premozenje[i]:0:2, ' '); WriteLn;
end.
