program Bisekcija; { RTK 1999.3.1 }
const MaxN = 100;
type TabelaT = array[1..MaxN] of integer;

function PoisciNajmanjsiElement(Iskani: integer; Tabela: TabelaT; 
                                Prvi, Zadnji: integer; 
                                var Indeks: integer): boolean; 
var 
  Spodnji, Zgornji, Vmes: integer; 
  Element: integer; 
  Nasel: boolean; 
begin
  Nasel := false; 
  Spodnji := Prvi; 
  Zgornji := Zadnji; 
  repeat 
    Vmes := (Spodnji + Zgornji) div 2; 
    Element := Tabela[Vmes]; 
    if Iskani = Element then Nasel := true; 
    if Iskani <= Element 
      then Zgornji := Vmes - 1 
      else Spodnji := Vmes + 1; 
  until Spodnji > Zgornji; 
  if Iskani > Element 
    then Indeks := Vmes + 1 
    else Indeks := Vmes; 
  PoisciNajmanjsiElement := Nasel; 
end; {PoisciNajmanjsiElement} 

var i, N, Iskani: integer; Tabela: TabelaT;
begin {Bisekcija}
  { Preberimo vhodne podatke. }
  ReadLn(N);
  for i := 1 to N do begin
    ReadLn(Tabela[i]);
    if i > 1 then if Tabela[i] < Tabela[i - 1] then
      begin WriteLn('Tabela ni urejenan naraajoe!'); Halt; end;
  end; {for}
  { Odgovarjajmo na poizvedbe. }
  while not Eof do begin
    ReadLn(Iskani); Write(Iskani, ' ');
    if PoisciNajmanjsiElement(Iskani, Tabela, 1, N, i) 
    then WriteLn('je v tabeli: Tabela[', i, '] = ', Tabela[i])
    else begin
      Write('ni v tabeli: vstaviti bi jo bilo treba');
      if i > 1 then Write(' za Tabela[', i - 1, '] = ', Tabela[i - 1]);
      if i <= N then Write(' pred Tabela[', i, '] = ', Tabela[i]);
      WriteLn;
    end; {if}
  end; {while}
end. {Bisekcija}
