program KrizciInKrozci; { RTK 2001.2.4 }
const MaxN = 20;
type ZnakT = (Krizec, Krozec);
     KockaT = array[0..MaxN - 1, 0..MaxN - 1, 0..MaxN - 1] of ZnakT;

  function Prestej(var Kocka: KockaT; N, M: integer): integer; 

    function JeZnak(X, Y, Z: integer; Znak: ZnakT): boolean; 
    begin
      if  (0 <= X) and (X < N) 
      and (0 <= Y) and (Y < N) 
      and (0 <= Z) and (Z < N) 
      then JeZnak := Kocka[X, Y, Z] = Znak
      else JeZnak := False;  
    end;
    
  var X, Y, Z, X0, Y0, Z0, DX, DY, DZ, Koliko, i, j: integer; 
      Znak: ZnakT; 
  begin {Prestej}
    Koliko := 0; 
    { Mone smeri otevilimo od 0 do 12. }
    for j := 0 to 12 do begin 
      { Smeri j ustreza smerni vektor (DX, DY, DZ). }
      DX := (j div 9) - 1; 
      DY := ((j div 3) mod 3) - 1; 
      DZ := (j mod 3) - 1; 
      { Poskusimo iti v tej smeri iz vsakega monega
        zaetnega poloaja, (X0, Y0, Z0). }
      for X0 := 0 to N - 1 do 
      for Y0 := 0 to N - 1 do 
      for Z0 := 0 to N - 1 do begin 
        X := X0; Y := Y0; Z := Z0; 
        Znak := Kocka[X, Y, Z]; { znak na trenutnem poloaju;
          moral bi biti tudi v nadaljnjih celicah v trenutni smeri }
        i := 1; { tevec, kako dolgo zaporedje teh znakov imamo }
        while i < M do begin 
          { Premaknimo se v smeri (DX, DY, DZ). }
          Inc(X, DX); Inc(Y, DY); Inc(Z, DZ); 
          { e se je zaporedje znakov Znak pretrgalo, nehajmo. }
          if not JeZnak(X, Y, Z, Znak) then break; 
          Inc(i); 
        end; {while}
        { Smo nali M enakih znakov v vrsti? }
        if i = M then Inc(Koliko); 
      end; {for X0, Y0, Z0} 
    end; {for j} 
    Prestej := Koliko; 
  end; {Prestej} 

var T: text; Kocka: KockaT; 
    N, M, X, Y, Z: integer; S: string;
begin {KrizciInKrozci}
  { Preberimo vhodno datoteko.  V prvi vrstici naj bosta N in M,
    nato pa N plasti kocke; vsaka plast ima N vrstic s po N znaki,
    pred tem pa e prazno vrstico. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk01s2n4.in');
  Reset(T); ReadLn(T, N, M);
  for Z := 0 to N - 1 do begin
    ReadLn(T);
    for Y := 0 to N - 1 do begin
      ReadLn(T, S);
      for X := 0 to N - 1 do 
        if (S[X] = 'X') or (S[X] = 'x') 
        then Kocka[X, Y, Z] := Krizec
        else Kocka[X, Y, Z] := Krozec;
    end; {for Y}
  end; {for Z}
  Close(T);
  
  WriteLn('tevilo zaporedij ', M, 
    ' enakih znakov v kocki s stranico ', N, ': ', 
    Prestej(Kocka, N, M));
end. {KrizciInKrozci}
