program Prefiksi; { RTK 2001.3.5 }
const MaxN = 100; MaxP = 100;
var 
  Vzorci: array[1..MaxN] of string[MaxP];
  Oznake: array[0..MaxP - 1] of boolean;
  S: array[0..MaxP - 1] of char;
  T: text; iBranje, iOznaka, iZadnja: longint; i, j, L, N, StOznak: integer;
begin  
  { Preberimo velikost mree. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'prefiksi.in'); 
  Reset(T); ReadLn(T, N);
  for j := 1 to N do ReadLn(T, Vzorci[j]);
  for i := 0 to MaxP - 1 do Oznake[i] := false;
  Oznake[0] := true; StOznak := 1;
  { Oznaujmo dosegljiva mesta v nizu. }
  iBranje := 0; iOznaka := 0; iZadnja := 0;
  while (iOznaka <= iBranje) or (not Eoln(T)) do begin
    if not Eoln(T) then { preberimo naslednji znak }
      begin Read(T, S[iBranje mod MaxP]); iBranje := iBranje + 1; end;
    if Eoln(T) or (iBranje >= MaxP) then begin
      if Oznake[iOznaka mod MaxP] then begin
        { Poglejmo, e se da od tega oznaenega mesta kako nadaljevati. }
        iZadnja := iOznaka; Oznake[iOznaka mod MaxP] := false; StOznak := StOznak - 1;
        for j := 1 to N do begin { primerjajmo S[iOznaka..] z vzorcem j }
          i := 1; L := Length(Vzorci[j]);
          while (i <= L) and (iOznaka + i - 1 < iBranje) do
            if S[(iOznaka + i - 1) mod MaxP] = Vzorci[j, i] then i := i + 1 else break;
          if i > L then if not Oznake[(iOznaka + L) mod MaxP] then { oznaimo doseeno mesto }
            begin Oznake[(iOznaka + L) mod MaxP] := true; StOznak := StOznak + 1; end;
        end; {for j}
        if StOznak = 0 then break;
      end; {if}
      iOznaka := iOznaka + 1;
    end; {if}
  end; {while}
  { Izpiimo rezultate. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'prefiksi.out'); 
  Rewrite(T); WriteLn(T, iZadnja); Close(T);
end. {Prefiksi}
