program Krajsanke; { RTK 2004 }
const MaxN = 3; MaxM = 3;
type TabelaT = array [1..MaxN] of string;

procedure IzpisiVseKrajsanke(M, N: integer; Besede: TabelaT);
type MnozicaT = set of 1..MaxN;
var 
  Skrajsanka: packed array [1..MaxN * MaxM] of char;
  Dolzina: integer;

  procedure Izpisi;
  var i: integer;
  begin
    for i := 1 to Dolzina do Write(Skrajsanka[i]);
    WriteLn;
  end; {Izpisi}
  
  procedure Rekurzija(Proste: MnozicaT);
  var StaraDolzina, i, j: integer;
  begin
    StaraDolzina := Dolzina;
    for i := 1 to N do if i in Proste then begin
      Proste := Proste - [i];
      for j := 0 to M do begin
        if j > Length(Besede[i]) then break;
        if j > 0 then Skrajsanka[StaraDolzina + j] := Besede[i][j];
        Dolzina := StaraDolzina + j;
        if Proste = [] then begin if Dolzina > 0 then Izpisi end
        else Rekurzija(Proste);
      end; {for j}
      Proste := Proste + [i];
    end; {for i}
    Dolzina := StaraDolzina;
  end; {Rekurzija}
  
var i: integer; Proste: MnozicaT;
begin {IzpisiVseKrajsanke}
  Dolzina := 0;
  Proste := [];
  for i := 1 to N do Proste := Proste + [i];
  Rekurzija(Proste);
end; {IzpisiVseKrajsanke}

var i, M, N: integer; Besede: TabelaT;
begin
  Val(ParamStr(ParamCount), M, i);
  N := ParamCount - 1;
  for i := 1 to N do Besede[i] := ParamStr(i);
  IzpisiVseKrajsanke(M, N, Besede);
end. {Krajsanke}
