program Sbn; { RTK 2004.3.2 }

{ Urejanje z mehurki (bubble sort).  
  Postopek je taken:
  
  for i := 1 to n - 1 do 
    -- V zadnjih i - 1 registrih se e nahaja i - 1 najvejih vrednosti
    -- cele tabele.  V tej iteraciji zunanje zanke bomo poskrbeli,
    -- da bo v register r[n - i + 1] prila (n - i + 1)-va najveja vrednost.
    for j := 1 to n - 1 do 
      if not (r[j] < r[j + 1]) then
        zamenjaj vrednosti r[j] in r[j + 1];
  
  Ker je telo zunanje zanke neodvisno od i, nam ni treba imeti
  po ene kopije kode te zanke za vsako iteracijo.  V spodnjem
  programu ustreza tevcu i register r255.  Dobljeno zaporedje
  ukazov je tako za urejanje n registrov dolgo le 3n - 1 ukazov. }

var T: text; j, n, Stevec, Temp: integer;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'sbn.in');
  Reset(T); ReadLn(T, n); Close(T);
  if ParamCount >= 1 then Assign(T, ParamStr(2)) else Assign(T, 'sbn.out');
  Rewrite(T);
  Stevec := n + 1; Temp := n + 2;
  WriteLn(T, 'sbn r', Stevec, ', 0, ', n - 1);              { tevec prehodov := -(n - 1) }
  Write(T, 'loop: ');
  for j := 1 to n - 1 do begin
    WriteLn(T, 'sbn r', Temp, ', r', j, ', r', j + 1, ', _', j);  { skok se izvede, e je r[j] < r[j + 1] }
    WriteLn(T, 'sbn r', j + 1, ', r', j, ', 0');            { zamenjajmo njuni vrednosti }
    WriteLn(T, 'sbn r', j, ', r', j, ' r', Temp);
    Write(T, '_', j, ': ');
  end; {for i}
  WriteLn(T, 'sbn r', Stevec, ', r', Stevec, ', -1, loop'); { po (n-1)-vem prehodu postane tevec negativen }
  Close(T);
end. {Sbn}
