program HotInsectAction; { RTK 2004.3.5 }
const MaxX = 10000; MaxY = 10000; 

  function Razdalja(X1, Y1, X2, Y2: integer): integer;
  var Z1, Z2, DX, DZ: integer;
  begin
    Assert((0 <= X1) and (X1 <= MaxX) and (0 <= Y1) and (Y1 <= MaxY));
    Assert((0 <= X2) and (X2 <= MaxX) and (0 <= Y2) and (Y2 <= MaxY));
    Z1 := Y1 - X1 div 2; Z2 := Y2 - X2 div 2;
    DX := X2 - X1; DZ := Z2 - Z1;
    if ((DX > 0) and (DZ > 0)) or ((DX < 0) and (DZ < 0))
    then Razdalja := Abs(DX) + Abs(DZ)
    else if Abs(DX) > Abs(DZ) then Razdalja := Abs(DX) else Razdalja := Abs(DZ);
  end; {Razdalja}

var MX, MY, VX, VY, i, X, Y: integer; T, U: text;
begin {HotInsectAction}

  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'maja.in');
  if ParamCount >= 2 then Assign(U, ParamStr(2)) else Assign(U, 'maja.out');
  Reset(T); Rewrite(U);
  ReadLn(T, MX, MY); 
  ReadLn(T, VX, VY); 
  for i := 1 to 3 do begin
    ReadLn(T, X, Y); 
    WriteLn(U, Razdalja(MX, MY, X, Y), ' ', Razdalja(VX, VY, X, Y));
  end; {for i}
  Close(T); Close(U);
  
end. {HotInsectAction}
