program Daljice(Input, Output); { RTK 1993.3.2 }
const Najvec = 1020; 
type 
  KoordT = integer; 
  EnaT = record 
    x, y: KoordT; 
    Link1, Link2: integer; 
  end; {EndT}
  TockeT = array[0..Najvec] of EnaT; 
var 
  Tocke: TockeT; 
  Zadnji: integer; 
  
  procedure Init; 
  var i: integer; 
  begin
    for i := 0 to Najvec do with Tocke[i] do Link1 := -2; 
  end; {Init} 
  
  function Preberi(var x1, y1, x2, y2: KoordT): boolean; 
  begin
    if Eof then Preberi := false
    else begin ReadLn(x1, y1, x2, y2); Preberi := true; end;
  end; {Preberi} 

  function Vstavi(x1, y1: KoordT): integer; 
  var Indeks, Prvi, Dodatek: integer; 
      Nasel: boolean; 
  begin
    Indeks := (x1 + y1) mod (Najvec + 1); 
    if Tocke[Indeks].Link1 <> -2 then begin
      Nasel := (Tocke[Indeks].x = x1) and (Tocke[Indeks].y = y1); 
      if not Nasel then begin 
        Prvi := Indeks; 
        Dodatek := 1 + ((x1 + y1) mod (Najvec - 1)); 
        repeat 
          Indeks := (Indeks + Dodatek) mod (Najvec + 1); 
          Nasel := (Tocke[Indeks].x = x1) and (Tocke[Indeks].y = y1); 
        until (Tocke[Indeks].Link1 = -2) or (Indeks = Prvi) or Nasel; 
        if (Indeks = Prvi) and (not Nasel) then 
          begin WriteLn('Tabela je polna!'); Halt; end;
      end; {if}
    end
    else Nasel := false; 
    if not Nasel then with Tocke[Indeks] do begin 
      Link1 := -1; Link2 := -1; 
      x := x1; y := y1; 
    end; {if}
    Vstavi := Indeks; 
  end; {Vstavi} 

  procedure PreberiUredi; 
  var xz, yz, xk, yk: KoordT; 
      tz, tk: integer; 
  begin
    Zadnji := -1; 
    while Preberi(xz, yz, xk, yk) do begin  { preberemo podatke o daljici } 
      tz := Vstavi(xz, yz);                 { poiemo/vstavimo podatke o prvem } 
      tk := Vstavi(xk, yk);                 { in drugem krajiu } 
      with Tocke[tz] do                     { poveemo prvo krajie z drugim } 
        if Link1 = -1 then Link1 := tk else Link2 := tk;  
      with Tocke[tk] do                     { in drugo s prvim } 
        if Link1 = -1 then Link1 := tz else Link2 := tz;  
      Zadnji := tk;                  { zapomnimo si zadnje vstavljeno krajie } 
    end; {while}
  end; {PreberiUredi} 

  procedure Izpisi; 
  var Tren, Nas: integer; 
  begin
    if Zadnji <> -1 then begin
      Tren := Zadnji; { izpisovati zanemo pri zadnjem krajiu } 
      Nas := Tocke[Tren].Link1; 
      if Nas <> -1 then repeat 
        WriteLn('(', Tocke[Tren].x, ',', Tocke[Tren].y, 
                ') - (', Tocke[Nas].x, ',', Tocke[Nas].y, ')'); 
        { premik v naslednje krajie; pazimo, da nadaljujemo v pravi smeri } 
        if Tren = Tocke[Nas].Link1  
          then begin Tren := Nas; Nas := Tocke[Nas].Link2; end
          else begin Tren := Nas; Nas := Tocke[Nas].Link1; end;
      until (Nas = -1) or (Tren = Zadnji); 
      if Nas = -1 then WriteLn('Link ni zaprt!'); 
    end; {if}
  end; {Izpisi} 

begin {Daljice} 
  Init; 
  PreberiUredi; 
  Izpisi; 
end. {Daljice} 
