program Zvonik; { RTK 1994.2.3 }
uses Crt;

  procedure PremakniKazalce; forward; 
  procedure UdariNaZvon; forward; 

procedure VsakoSekundo;
const
  DoPomika: integer = 60;    { sekund do pomika kazalcev } 
  DoPolneUre: integer = 0;   { sekund do polne ure } 
  DoUdarca: integer = 0;     { sekund do udarca na zvon } 
  Udarcev: integer = 0;      { potrebno odbiti e toliko udarcev } 
  Ura: integer = 11;         { koliko je ura } 
begin
  if DoPomika > 0 then DoPomika := DoPomika - 1 
  else begin PremakniKazalce; DoPomika := 59; end;
  if DoPolneUre > 0 then DoPolneUre := DoPolneUre - 1 
  else begin 
    if Ura < 12 then Ura := Ura + 1 else Ura := 1; 
    Udarcev := Ura; DoPolneUre := 3600 - 1; 
  end; {if}
  if DoUdarca > 0 then DoUdarca := DoUdarca - 1 
  else if Udarcev > 0 then begin 
    UdariNaZvon; Udarcev := Udarcev - 1; DoUdarca := 2; 
  end; {if}
end; {VsakoSekundo} 

var h, m, s, hk, mk: integer; Bim: boolean;

procedure PremakniKazalce; 
begin
  mk := mk + 1;
  if mk = 60 then begin
    mk := 0; hk := hk + 1;
    if hk > 12 then hk := 1;
  end; {if}
end; {PremakniKazalce}

procedure UdariNaZvon;
begin
  Bim := true;
end; {UdariNaZvon}

const IAO = 'IAO'; 
var iBim: integer; c: char;
begin {Zvonik}

  h := 0; m := 0; s := 0; hk := 12; mk := 0; iBim := 1;
  while true do begin
    Bim := false;
    
    VsakoSekundo;
    
    Write('T = ', h div 10, h mod 10, ':', m div 10, m mod 10, ':', s div 10, s mod 10, '   ');
    Write('Kazalca: ', hk:2, ':', mk div 10, mk mod 10);
    if Bim then begin 
      Write('  B', IAO[iBim], 'M!'); 
      iBim := (iBim mod 3) + 1; 
    end; {if}
    WriteLn;
    
    if KeyPressed then begin
      c := UpCase(ReadKey); if c = #0 then c := ReadKey;
      if (c = 'Q') or (c = 'X') then break;
      if (c = 'P') then begin
        Write('(pavza)', #13);
        c := UpCase(ReadKey); if c = #0 then c := ReadKey;
        if (c = 'Q') or (c = 'X') then break;
      end; {if}
    end; {if}
    
    s := s + 1;
    if s >= 60 then begin 
      s := 0; m := m + 1;
      if m >= 60 then begin
        m := 0; h := h + 1;
        if h >= 24 then h := 0;
      end; {if}
    end; {if}
  end; {while}
    
end. {Zvonik}
