program Zanke; { RTK 1997.3.1 }
{ Da ne bomo tule komplicirali s kazalci, bomo
  seznam predstavili kar s tabelo, v kateri vsak
  element vsebuje indeks naslednjega lena tabele. }
const MaxN = 20;
var Naslednji: array[1..MaxN] of integer;

procedure NarediSeznam(N, Zanka: integer);
var i: integer;
begin
  for i := 1 to N - 1 do Naslednji[i] := i + 1;
  Naslednji[N] := Zanka;
end; {NarediSeznam}

function DvojnaHitrost: boolean; 
var p1, p2: integer; 

  procedure PrikaziStanje;
  var i, p: integer;
  begin
    i := 1; p := 0;
    while i > p do 
      begin Write(i:3, ' '); p := i; i := Naslednji[i]; end;
    WriteLn('  (--> ', i, ')');
    i := 1;
    while Naslednji[i] > i do begin 
      if i = p1 then
        if i = p2 then Write('^12 ')
        else Write(' ^1 ')
      else if i = p2 then Write(' ^2 ')
      else Write('    ');
      i := Naslednji[i];
    end; {while}
    Write(' ');
    if p1 = 0 then Write(' p1=nil');
    if p2 = 0 then Write(' p2=nil');
    WriteLn;
  end; {PrikaziStanje}

var nIter: integer;
begin
  p1 := 1; 
  p2 := 1; 
  PrikaziStanje; nIter := 0;
  repeat 
    if p1 <> 0 then p1 := Naslednji[p1]; 
    if p2 <> 0 then p2 := Naslednji[p2];
    if p2 <> 0 then p2 := Naslednji[p2];
    PrikaziStanje; Inc(nIter);
  until (p1 = 0) or (p2 = 0) or (p1 = p2); 
  DvojnaHitrost := (p1 <> 0) and (p2 <> 0); 
  WriteLn('tevilo iteracij zanke repeat: ', nIter);
end; {DvojnaHitrost} 

var N, Zanka, i: integer;
begin {Zanke}
  if ParamCount < 2 then begin 
    WriteLn('rtk97s3n1 n m');
    WriteLn('  Seznam bo imel n elementov, naslednik zadnjega bo m.');
    WriteLn('  m = 0 pomeni navaden seznam, 1 <= m <= n pa zanko.');
    exit;
  end; {if}
  Val(ParamStr(1), N, i); Val(ParamStr(2), Zanka, i);
  NarediSeznam(N, Zanka);
  if DvojnaHitrost then WriteLn('DvojnaHitrost vrne true.')
  else WriteLn('DvojnaHitrost vrne false.');
  Write('tevilo iteracij bi moralo biti: ');
  if N = 0 then WriteLn(1)
  else if Zanka = 0 then WriteLn((N + 1) div 2)
  else if Zanka = 1 then WriteLn(N)
  else WriteLn(Zanka - 1 + ((Zanka - 1) * (N - Zanka)) mod (N - Zanka + 1));
end. {Zanke}
