program Izpisi; { RTK 2000.1.4 }

var Seznam: text;

  { Za ta podprogram so tekmovalci lahko predpostavili, da je e podan.
    Prebere eno vrstico oblike 'Izvajalec, Album, Skladba'.
    Poljubno od teh treh polj je lahko tudi v narekovajih:
    vrstica 'Ena, "Dve, ""Tri""", Sti''ri' bi dala
    Izvajalec = 'Ena', Album = 'Dve, "Tri"', Skladba = 'Sti''ri'. }
  function Komad(var Izvajalec, Album, Skladba: string): boolean;
  var S: string; i, L: integer;
  
    procedure BeriPolje(var T: string);
    const Presledki = [' ', #9];
    var Nar: boolean; j: integer;
    begin
      T := ''; Nar := false;
      { Preskoimo presledke pred poljem. }
      while i <= L do if S[i] in Presledki then i := i + 1 else break;
      { Je to polje v narekovajih? }
      if i <= L then if S[i] = '"' then
        begin Nar := true; i := i + 1; end;
      while i <= L do 
        if Nar and (S[i] = '"') then begin
          { Dva zaporedna narekovaja se spremenita v enega. }
          if i + 1 <= L then if S[i + 1] = '"' then 
            begin T := T + S[i]; i := i + 2; continue; end;
          { En narekovaj pomeni konec polja. }
          i := i + 1; break;
        end else if (not Nar) and (S[i] = ',') then 
          break { Vejica pomeni konec polja. }
        else { Navaden znak, ki ga dodamo nizu T. }
          begin T := T + S[i]; i := i + 1; end;
      { Poiimo in preskoimo vejico za poljem. }
      while i <= L do if S[i] = ',' then break else i := i + 1;
      i := i + 1; 
      { Poreimo morebitne presledke na koncu polja. }
      j := Length(T); while j > 0 do
        if T[j] in Presledki then j := j - 1 else break;
      T := Copy(T, 1, j);
    end; {BeriPolje}
  
  begin {Komad}
    if Eof(Seznam) then begin Komad := false; exit; end;
    ReadLn(Seznam, S); L := Length(S); i := 1;
    BeriPolje(Izvajalec);
    BeriPolje(Album);
    BeriPolje(Skladba);
    Komad := true;
  end; {Komad}
  
var SirIzv, SirAlb: integer; { irine stolpcev }
    Izvajalec, Album, Skladba: string; 
    PrejIzv, PrejAlbum: string; 
begin {Izpisi}
  if ParamCount >= 1 then Assign(Seznam, ParamStr(1))
  else Assign(Seznam, 'rtk00s1n4.in');
  SirIzv := 0; SirAlb := 0; 
  Reset(Seznam);
  while Komad(Izvajalec, Album, Skladba) do begin 
    if Length(Izvajalec) > SirIzv then SirIzv := Length(Izvajalec); 
    if Length(Album) > SirAlb then SirAlb := Length(Album); 
  end; {while}
  Inc(SirIzv, 2); Inc(SirAlb, 2); { po dva presledka med stolpci } 
  PrejIzv := ''; { da bomo prvega izvajalca izpisali v celoti } 
  Reset(Seznam);
  while Komad(Izvajalec, Album, Skladba) do begin 
    if Izvajalec <> PrejIzv then begin { nov izvajalec } 
      WriteLn(Izvajalec, ' ':(SirIzv - Length(Izvajalec)), 
              Album, ' ':(SirAlb - Length(Album)), Skladba); 
      PrejIzv := Izvajalec; PrejAlbum := Album;  
    end else if Album <> PrejAlbum then begin { nov album } 
      WriteLn(' ':SirIzv, Album, ' ':(SirAlb - Length(Album)), Skladba); 
      PrejAlbum := Album; 
    end else begin 
      WriteLn(' ':SirIzv, ' ':SirAlb, Skladba); 
    end; {if}
  end; {while}
  Close(Seznam);
end. {Izpisi} 
