program CiscenjeHTMLja; { RTK 2000.2.3 }
{ Ta program bere s standardnega vhoda 
  in pie na standardni izhod. }

  { Primerja dva niza, le da ne loi velikih in malih rk.
    Enak uinek bi lahko dosegli z "UpCase(S) = UpCase(T)",
    e nae nareje pascala podpira UpCase tudi na nizih,
    ne le na rkah. }
  function Enaki(S, T: string): boolean;
  var i: integer;
  begin
    if Length(S) <> Length(T) then 
      begin Enaki := false; exit; end
    else for i := 1 to Length(S) do 
      if UpCase(S[i]) <> UpCase(T[i]) then 
        begin Enaki := false; exit; end;
    Enaki := true; 
  end; {Enaki}

const 
  N = 10; 
  Prepovedana: array[1..N] of string = (
    'FONT', 'APPLET', 'OBJECT', 'PARAM', 'BIG', 'SMALL', 
    'B', 'U', 'I', 'S');

var C: char; S: string; EndTag, Ok, Gt: boolean; i: integer; 
begin
  while not Eof do begin
    Read(C); 
    if C <> '<' then begin Write(C); continue; end; 
    { Preberimo ime oznake. } 
    S := ''; EndTag := false; Gt := false; 
    while not Eof do begin
      Read(C); 
      if C = '/' then EndTag := true{ To je oznaka za konec elementa. } 
      else if not (C in ['A'..'Z', 'a'..'z', '0'..'9']) then 
        begin Gt := C = '>'; break; end { Konec imena oznake. } 
      else S := S + C; 
    end; {while}
    { Berimo do konca oznake (do znaka '>'), da preskoimo atribute. 
      Mogoe smo znak '>' celo e prebrali -- to pove spremenljivka Gt. }
    if not Gt then while not Eof do 
      begin Read(C); if C = '>' then break; end; 
    { Preverimo, e je oznaka prepovedana. } 
    Ok := true; i := 1; 
    while (i <= N) and Ok do 
      begin Ok := not Enaki(S, Prepovedana[i]); Inc(i); end;
    if Ok then begin { Izpiimo oznako. } 
      Write('<');  
      if EndTag then Write('/'); 
      Write(S, '>'); 
    end; {if}
  end; {while}
end. {CiscenjeHTMLja}
