program RadarZNeurejenoTabelo; { RTK 2003.1.4 }
const N = 20; 
var Tabela: array[1..N] of real; 
    i, KjeNajmanjsi: integer; 
    T: text; x: real; 
begin
  { Odprimo vhodno datoteko. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'podatki.txt');
  Reset(T); 
  { Berimo podatke in sproti pomnimo 20 najvejih. 
    'KjeNajmanjsi' pove, kateri element tabele Tabela
    je najmanji (torej najmanji med 20 najvejimi). }
  KjeNajmanjsi := 1; for i := 1 to N do Tabela[i] := 0; 
  while not Eof(T) do begin 
    ReadLn(T, x); 
    if x > Tabela[KjeNajmanjsi] then begin
      { Element, ki je bil doslej v Tabela[KjeNajmanjsi], 
        ni ve med 20 najvejimi.  ezenj napiimo x, nato 
        pa se sprehodimo po tabeli, da vidimo, kateri je po
        novem najmanji v njej. }
      Tabela[KjeNajmanjsi] := x; 
      for i := 1 to N do 
        if Tabela[i] < Tabela[KjeNajmanjsi] then KjeNajmanjsi := i; 
    end; {if}
  end; {while}
  Close(T); 
  { Izpiimo 20 najvejih meritev. }
  for i := 1 to N do WriteLn(Tabela[i]:0:2); 
end. {RadarZNeurejenoTabelo} 
