{$M 16384,0,0}
program MeriCas;
uses Crt, Dos;
const
  MaksBesed = 1000;
type
  BesedaTip = string [ 20 ];
var
  ZacUra, ZacMin, ZacSek, ZacStot : word;
  KonUra, KonMin, KonSek, KonStot : word;
  ZacCas, KonCas : longint;
  fRezultat, fZahteva, fAnaliza : text;
  BesedaTab : array [ 1..MaksBesed ] of BesedaTip;
  RezBeseda : string;
  Besed, StBesede : integer;
  VseOk : boolean;
begin
  Assign ( fAnaliza, 'ANALIZA.TXT' ); Rewrite ( fAnaliza );

  Assign ( fRezultat, 'REZULTAT.TXT' );
  {$I-} Erase ( fRezultat ); {$I+}

  GetTime ( ZacUra, ZacMin, ZacSek, ZacStot );
  Exec ( ParamStr ( 1 ), '' );
  GetTime ( KonUra, KonMin, KonSek, KonStot );
  if DosError <> 0 then begin
    case DosError of
       2 : writeln ( 'DOS Error: File not found' );
       3 : writeln ( 'DOS Error: Path not found' );
       5 : writeln ( 'DOS Error: Access denied' );
       6 : writeln ( 'DOS Error: Invalid handle' );
       8 : writeln ( 'DOS Error: Not enough memory' );
      10 : writeln ( 'DOS Error: Invalid environment' );
      11 : writeln ( 'DOS Error: Invalid format' );
      18 : writeln ( 'DOS Error: No more files' );
    else
      writeln ( 'Neznana napaka' );
    end;
    Halt;
  end;
  ZacCas := Longint ( ZacUra ) * 360000 + Longint ( ZacMin ) * 6000 +
   Longint ( ZacSek ) * 100 + Longint ( ZacStot );
  KonCas := Longint ( KonUra ) * 360000 + Longint ( KonMin ) * 6000 +
   Longint ( KonSek ) * 100 + Longint ( KonStot );
  writeln ( fAnaliza, 'Program ', ParamStr ( 1 ),
   ' se je izvajal ', ( KonCas - ZacCas ) / 100:0:2, ' sekund.' );

  Assign ( fRezultat, 'REZULTAT.TXT' ); {$I-} Reset ( fRezultat ); {$I+}
  if IOResult <> 0 then begin
    writeln ( fAnaliza, 'Napaka: Datoteka ''REZULTAT.TXT'' ne obstaja.' );
  end else begin
    Assign ( fZahteva, 'ZAHTEVA.TXT' ); Reset ( fZahteva );
    Besed := 0;
    while not Eof ( fZahteva ) do begin
      Inc ( Besed ); ReadLn ( fZahteva, BesedaTab [ Besed ] );
    end;
    Close ( fZahteva );
    VseOk := true;
    while not Eof ( fRezultat ) do begin
      ReadLn ( fRezultat, RezBeseda );
      StBesede := 1;
      while ( StBesede <= Besed ) and
       ( RezBeseda <> BesedaTab [ StBesede ] ) do begin
        Inc ( StBesede );
      end;
      if StBesede > Besed then begin
        writeln ( fAnaliza, 'Nepravilna beseda "', RezBeseda, '".' );
        VseOk := false;
      end else begin
        BesedaTab [ StBesede ] := '';
      end;
    end;
    for StBesede := 1 to Besed do begin
      if BesedaTab [ StBesede ] <> '' then begin
        writeln ( fAnaliza, 'Manjkajoca beseda "',
         BesedaTab [ StBesede ], '".' );
        VseOk := false;
      end;
    end;
    if VseOk then begin
      writeln ( fAnaliza, 'Program je nasel vse besede.' );
    end;
  end;
  Close ( fRezultat );

  Close ( fAnaliza );
end.