program MengerjevaSpuzva; { RTK 2003.X.2 }
var nIter: int64;

{ V nn naj bo vrednost 3^n.
  Enako velja tudi za ostala dva podprograma. }
function JePrisotna(x, y, z, nn: integer): boolean;
var i, nn1: integer;
begin
  while nn > 1 do begin
    nIter := nIter + 1;
    { Koliko koordinat ima prvo tevko 1? }
    i := 0; nn1 := nn div 3;
    if x div nn1 = 1 then i := i + 1;
    if y div nn1 = 1 then i := i + 1;
    if z div nn1 = 1 then i := i + 1;
    if i >= 2 then break;
    { Poreimo prvo tevko vseh koordinat. }
    x := x mod nn1; y := y mod nn1; z := z mod nn1; nn := nn1;
  end; {while}
  { e se ustavimo prej kot pri nn = 1, pomeni, da se je 
    zanka konala s stavkom break, ker smo naleteli na luknjo. }
  JePrisotna := (nn = 1);
end; {JePrisotna}

procedure NarisiRezino(var T: text; z, nn: integer); 
var x, y: integer;
begin
  for y := 0 to nn - 1 do begin
    for x := 0 to nn - 1 do 
      if JePrisotna(x, y, z, nn) 
      then Write(T, '#') else Write(T, '.');
    WriteLn(T);
  end; {for y}
end; {NarisiRezino}

function StPojavitevRezine(z, nn: integer): integer; 
var s: integer;
begin
  s := 1;
  while nn > 1 do begin
    nn := nn div 3;
    { e ni iz srednje tretjine, je tevilo pojavitev dvakrat tolikno. }
    if z div nn <> 1 then s := s * 2;
    z := z mod nn;
  end; {while}
  StPojavitevRezine := s;
end; {StPojavitevRezine}

var i, z, n, nn: integer; T: text;
begin {MengerjevaSpuzva}
  Assign(T, 'kocka.in'); Reset(T); ReadLn(T, n, z); Close(T); 
  z := z - 1;
  nn := 1; for i := 1 to n do nn := nn * 3;
  Assign(T, 'kocka.out'); Rewrite(T);
  WriteLn(T, 'Vzorec ', z + 1, '. rezine se pojavi ', StPojavitevRezine(z, nn), '-krat.');
  NarisiRezino(T, z, nn);
  Close(T);
end. {MengerjevaSpuzva}
